#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <conio.h>

const int BUF_SIZE = 256;
const int BUF_HALF = 128;
const int SBUF_SIZE = 16;

const int ADPCM_UNIT = 32;

struct adpcm_common{
 double wav_buf[BUF_SIZE];
 double psycho_ac_big[BUF_HALF];
 double psycho_ac[SBUF_SIZE];
 double feedbacks[SBUF_SIZE];
 double errors_bf[SBUF_SIZE];
 double ath_curve[BUF_HALF];
 double mask_spread[BUF_HALF];
 double mask_spread_norm[BUF_HALF];

 char wav_comp[ADPCM_UNIT];
 int sign_hist[4];
 int evalfs_hist[22];
 int evalfe_hist[22];
 int feedbacks_max;
 //wav_buf ݃GR[h悤ƂĂ錳g`0`ADPCM_UNIT-1ɁA
 //        ꂩ̖̔g``BUF_SIZE-1܂œĂB
 //psycho_ac 0`TvOg2[Hz]܂ł̎gƂ̋emCY
 //          (}XLOl)ĂBjAB傫
 //          mCYƁAɂȂB
 //feedbacks tB[hobNWBfeedbacks[0]͕K1.0B
 //          feedbacks_max-1܂ŒlĂāAȍ~0.0B
 //errors_bf ςݏグG[Bwav_bufɃG[㏑ƁA
 //          ̔g`𒲂ׂȂȂ邽߁Aerror_bfɕۊǂB
 //ath_curve Ήl(ATH)BjAB
 //mask_spread }XLOBBUF_HALF̎gт̒ŁA1ш
 //            փ}XNLxB1barkшւ-10dBxA
 //            1barkႢшւ-25dBx}XNL炵B
 //mask_spread_norm ̂܂܃}XNLƁA͍L₷̂ŁA
 //                 Zƍ悪傫ȂĂ܂̂ŁAWB


 //wav_comp  8bitɈkʂi[B

};

int init_adpcm_common(struct adpcm_common *adpc){
 for(int i=0;i<BUF_SIZE;i++)adpc->wav_buf[i] = 0;
 for(int i=0;i<BUF_HALF;i++)adpc->psycho_ac_big[i] = 100.0;
 for(int i=0;i<SBUF_SIZE;i++)adpc->psycho_ac[i] = 0;
 for(int i=0;i<SBUF_SIZE;i++)adpc->feedbacks[i] = 0;
 for(int i=0;i<SBUF_SIZE;i++)adpc->errors_bf[i] = 0;
 for(int i=0;i<BUF_HALF;i++)adpc->ath_curve[i] = 0;
 for(int i=0;i<BUF_HALF;i++)adpc->mask_spread[i] = 0;
 for(int i=0;i<BUF_HALF;i++)adpc->mask_spread_norm[i] = 0;
 for(int i=0;i<ADPCM_UNIT;i++)adpc->wav_comp[i] = 0;
 for(int i=0;i<4;i++)adpc->sign_hist[i] = 0;
 adpc->feedbacks_max = 8;
 adpc->feedbacks[0] = 1.0;
 return 0;
}

int prepare_psycho_param(struct adpcm_common *adpc,double s_rate){
 // ISO 226 :2003 standard 20phon
 //   bark             0   1    2    3    4    5    6    7    8    9    10   11   12   13   14   15   16   17   18   19   20   21   22   23    24    25    26    27    28
 //double barkgen[27]={0, 100, 200, 300, 400, 510, 630, 770, 920, 1080,1270,1480,1720,2000,2320,2700,3150,3700,4400,5300,6400,7700,9500,12000,15500,27000,300000};
 double athcgen[27] = {60, 46, 34,  28,  26,  23,  22,  21,  20,   20,  21,  22,  21,  19,  17,  16,  14,  15,  16,  19,  24,  30,  34,  35,   32,   86,   84};
 double hz = 0.4*s_rate/BUF_SIZE;
 double bark = 13.0*atan(hz*0.00076)+3.5*atan((hz/7500.0)*(hz/7500.0));
 int i;
 for(i=0;i<BUF_HALF;i++){
  double db;
  db = athcgen[(int)bark]+(bark-((int)bark))*(athcgen[1+(int)bark]-athcgen[(int)bark]);

  hz += s_rate/BUF_SIZE;
  double newbark = 13.0*atan(hz*0.00076)+3.5*atan((hz/7500.0)*(hz/7500.0));

  adpc->ath_curve[i] = pow(10.0,db/20.0);
  adpc->mask_spread[i] = pow(0.316,(newbark-bark)*1.2);//12,24dB
  bark = newbark;
 }
 double mask_thre = 0.0;
 for(i=0;i<BUF_HALF;i++){
  mask_thre += 1.0;
  adpc->mask_spread_norm[i] = mask_thre;
  mask_thre *= adpc->mask_spread[i];
 }
 mask_thre = 0.0;
 for(i=BUF_HALF-1;i>=0;i--){
  mask_thre += adpc->mask_spread_norm[i];
  adpc->mask_spread_norm[i] = mask_thre;
  mask_thre *= adpc->mask_spread[i];
  mask_thre *= adpc->mask_spread[i];
 }
 for(i=0;i<BUF_HALF;i++){
  adpc->mask_spread_norm[i] = pow(10.0,71.0/20.0)/adpc->mask_spread_norm[i];
 }

 return 0;
}

void fft1(double ar[], double ai[], int n, int iter, int flag){
	int i, it, j, j1, j2, k, xp, xp2;
	double arg, dr1, dr2, di1, di2, tr, ti, w, wr, wi;

	if(n < 2)
	{
		fprintf(stderr, "Error : n < 2  in fft1()\n");
		return;
	}
	if(iter <= 0)
	{
		iter = 0;
		i = n;
		while((i /= 2) != 0)	iter++;
	}
	j = 1;
	for(i = 0; i < iter; i++)	j *= 2;
	if(n != j)
	{
		fprintf(stderr, "Error : n != 2 ^ k  in fft1()\n");
		return;
	}
	w = (flag? M_PI: -M_PI) / (double)n;
	xp2 = n;
	for(it = 0; it < iter; it++)
	{
		xp = xp2;
		xp2 /= 2;
		w *= 2;
		for(k = 0, i = - xp; k < xp2; i++)
		{
			wr = cos(arg = w * k++);
			wi = sin(arg);
			for(j = xp; j <= n; j += xp)
			{
				j2 = (j1 = j + i) + xp2;
				tr = (dr1 = ar[j1]) - (dr2 = ar[j2]);
				ti = (di1 = ai[j1]) - (di2 = ai[j2]);
				ar[j1] = dr1 + dr2;
				ai[j1] = di1 + di2;
				ar[j2] = tr * wr - ti * wi;
				ai[j2] = ti * wr + tr * wi;
			}
		}
	}
	j = j1 = n / 2;
	j2 = n - 1;
	for(i = 1; i < j2; i++)
	{
		if(i < j)
		{
			w = ar[i];
			ar[i] = ar[j];
			ar[j] = w;
			w = ai[i];
			ai[i] = ai[j];
			ai[j] = w; 
		}
		k = j1;
		while(k <= j)
		{
			j -= k;
			k /= 2;
		}
		j += k;
	}
	if(flag==0)return;
	w = 1. / sqrt(n);
	for(i = 0; i < n; i++)
	{
		ar[i] *= w;
		ai[i] *= w;
	}
	return;
}

double eval_feedbacks(double psycho_ac[SBUF_SIZE],double feedbacks[SBUF_SIZE],int fb_max){
 double ar[SBUF_SIZE*2];
 double ai[SBUF_SIZE*2];
 double score = 0.0;
 int i,j,k;

 double plzero;
 /*
 ai[0] = 1.0;
 for(i=1;i<=fb_max;i++){
  ai[i] = 0.0;
 }
 for(k=0;k<0;k++){
  for(i=fb_max;i;i--){
   plzero = ai[0];
   for(j=0;j<fb_max-1;j++){
    ai[j] = ai[j+1];
   }
   for(j=fb_max-1;j;j--){
    ai[j-1] -= plzero*feedbacks[j];
   }
  }
  plzero = 0.0;
  for(i=0;i<fb_max;i++){
   plzero += abs(ai[i]);
  }
  if(plzero<0.25)break;
  if(plzero>4.0)break;
 }
 plzero = pow(plzero,16/(k+1));
 */
 for(i=0;i<fb_max;i++){
  ai[i] = 0.0;
  ar[i] = feedbacks[i];
 }
 for(i=fb_max;i<SBUF_SIZE*2;i++){
  ar[i] = ai[i] = 0.0;
 }

 fft1(ar,ai,SBUF_SIZE*2,0,0);
 for(i=0;i<SBUF_SIZE;i++){
  score += (sqrt(ar[i]*ar[i]+ai[i]*ai[i]+0.36)*psycho_ac[i]);
 }
 //score *= (1.0+plzero);
 return score;
}

double optimize_feedbacks(struct adpcm_common *adpc){
 double feedbacks_new[SBUF_SIZE];
 double feedbacks_alt[SBUF_SIZE];
 double feedbacks_deltaf[SBUF_SIZE];
 double feedbacks_distance;
 double feedbacks_center_score;
 double feedbacks_new_score;
 int i,j,k;
 int scale = 4;
 int fb_max = adpc->feedbacks_max;
 feedbacks_alt[0] = 1.0;
 for(i=1;i<SBUF_SIZE;i++)feedbacks_alt[i] = 0;
 for(k=0;k<6;k++){
  feedbacks_center_score = eval_feedbacks(adpc->psycho_ac,feedbacks_alt,fb_max);
  feedbacks_distance = 0.0;

  for(i=1;i<fb_max;i++){
   for(j=0;j<SBUF_SIZE;j++)feedbacks_new[j] = feedbacks_alt[j];
   feedbacks_new[i] += 0.01;//delta
   feedbacks_deltaf[i] = eval_feedbacks(adpc->psycho_ac,feedbacks_new,fb_max)-feedbacks_center_score;
   feedbacks_distance += feedbacks_deltaf[i]*feedbacks_deltaf[i];
  }
  while(scale<10){
   double dist = (1<<scale)*0.01/sqrt(feedbacks_distance);
   for(j=1;j<fb_max;j++){
    feedbacks_new[j] = feedbacks_alt[j] - feedbacks_deltaf[j]*dist;
   }
   feedbacks_new_score = eval_feedbacks(adpc->psycho_ac,feedbacks_new,fb_max);
   if(feedbacks_new_score<feedbacks_center_score){
    for(j=1;j<fb_max;j++){
     feedbacks_alt[j] = feedbacks_new[j];
    }
    feedbacks_center_score = feedbacks_new_score;
    scale++;
   }
   else{
    break;
   }
  }
  if(scale){
   scale--;
  }
  else{
   break;
  }
 }
 if(feedbacks_center_score<eval_feedbacks(adpc->psycho_ac,adpc->feedbacks,fb_max)){
  for(j=1;j<fb_max;j++)adpc->feedbacks[j] = feedbacks_alt[j];
  //printf("%f\r\n",feedbacks_center_score);
 }
 scale = 4;

 for(k=0;k<22;k++){
  feedbacks_center_score = eval_feedbacks(adpc->psycho_ac,adpc->feedbacks,fb_max);
  feedbacks_distance = 0.0;

  for(i=1;i<fb_max;i++){
   for(j=0;j<SBUF_SIZE;j++)feedbacks_new[j] = adpc->feedbacks[j];
   feedbacks_new[i] += 0.0001;//delta
   feedbacks_deltaf[i] = eval_feedbacks(adpc->psycho_ac,feedbacks_new,fb_max)-feedbacks_center_score;
   feedbacks_distance += feedbacks_deltaf[i]*feedbacks_deltaf[i];
  }
  while(scale<15){
   if(scale<adpc->evalfs_hist[k])adpc->evalfs_hist[k] = scale;
   if(scale>adpc->evalfe_hist[k])adpc->evalfe_hist[k] = scale;
   double dist = (1<<scale)*0.0005/sqrt(feedbacks_distance);
   for(j=1;j<fb_max;j++){
    feedbacks_new[j] = adpc->feedbacks[j] - feedbacks_deltaf[j]*dist;
   }
   feedbacks_new_score = eval_feedbacks(adpc->psycho_ac,feedbacks_new,fb_max);
   if(feedbacks_new_score<feedbacks_center_score){
    for(j=1;j<fb_max;j++){
     adpc->feedbacks[j] = feedbacks_new[j];
    }
    feedbacks_center_score = feedbacks_new_score;
    scale++;
   }
   else{
    break;
   }
  }
  if(scale<2)break;
  scale -= 3;
  if(scale<0)scale = 0;
 }

 double ar[SBUF_SIZE*2];
 double ai[SBUF_SIZE*2];
 if(adpc->sign_hist[0]<4){
  for(i=0;i<SBUF_SIZE;i++){
   ai[i] = 0;
   ar[i] = adpc->feedbacks[i];
  }
  for(i=SBUF_SIZE;i<SBUF_SIZE*2;i++){
   ar[i] = ai[i] = 0;
  }
  fft1(ar,ai,SBUF_SIZE*2,0,0);
  printf("feedback:");
  for(i=0;i<SBUF_SIZE;i++){
   printf("%d ",(int)(adpc->feedbacks[i]*1000));
  }
  printf("\r\n masking:");
  for(i=0;i<SBUF_SIZE;i++){
   printf("%d ",(int)(-log10(adpc->psycho_ac[i])*(20.0)));
  }
  printf("\r\n   noise:");
  for(i=0;i<SBUF_SIZE;i++){
   printf("%d ",(int)(log10(sqrt(ar[i]*ar[i]+ai[i]*ai[i]))*20.0));
  }
  printf("\r\n   start:");
  for(i=0;i<22;i++){
   printf("%d ",10+adpc->evalfs_hist[i]);
  }
  printf("\r\n     end:");
  for(i=0;i<22;i++){
   printf("%d ",10+adpc->evalfe_hist[i]);
  }
  printf("\r\n");

 }

 return feedbacks_center_score;
}

int adpcm(struct adpcm_common *adpc){
 double ar[BUF_SIZE];
 double ai[BUF_SIZE];
 double psycho_ac_tmp[BUF_HALF];
 int psycho_ac_shrink_mask = (BUF_HALF/SBUF_SIZE);
 int psycho_ac_shrink_shift = 0;
 while((1<<psycho_ac_shrink_shift)<psycho_ac_shrink_mask)psycho_ac_shrink_shift++;
 //psycho_ac_shrink_mask--;

 int i,j;
 int fb_max = adpc->feedbacks_max;
 for(i=0;i<BUF_SIZE;i++){
  double sinw = sin((i+0.5)*3.141592653589/BUF_SIZE);
  ar[i] = adpc->wav_buf[i]*sinw*sinw;
  ai[i] = 0;
 }
 fft1(ar,ai,BUF_SIZE,0,0);
 double mask_thre;
 double biased_wav,error_wav,dithered_wav;
 int dequant_wav;
 int output_wav;
 mask_thre = 0.0;
 for(i=0;i<BUF_HALF;i++){
  mask_thre += (sqrt((ar[i]*ar[i]+ai[i]*ai[i])));
  psycho_ac_tmp[i] = mask_thre;
  mask_thre *= adpc->mask_spread[i];
  if(i<SBUF_SIZE)adpc->psycho_ac[i] = 0.0;
 }
 mask_thre = 0.0;
 for(i=BUF_HALF-1;i>=0;i--){
  mask_thre += psycho_ac_tmp[i];
  psycho_ac_tmp[i] = mask_thre*adpc->mask_spread_norm[i]+adpc->ath_curve[i];
  mask_thre *= adpc->mask_spread[i];
  mask_thre *= adpc->mask_spread[i];
 }

 for(i=0;i<BUF_HALF;i++){
  adpc->psycho_ac_big[i] = adpc->psycho_ac_big[i]*0.75+psycho_ac_tmp[i]*0.25;
  adpc->psycho_ac[i>>psycho_ac_shrink_shift] += 1.0/(adpc->psycho_ac_big[i]);
 }
 for(i=0;i<22;i++){
  adpc->evalfs_hist[i] = 32;
  adpc->evalfe_hist[i] = 0;
 }
 double feedbacks_score;
 double quant_step = 256.0;
 int quant_step_int = 0;

 feedbacks_score = optimize_feedbacks(adpc);

 //while((feedbacks_score*256.0)<quant_step && quant_step_int<7){
 // quant_step *= 0.5;
 // quant_step_int++;
 //}

 for(i=0;i<ADPCM_UNIT;i++){
  biased_wav = adpc->wav_buf[i]-adpc->errors_bf[1];
  dithered_wav = biased_wav + (0.31*atan((rand()*4.0-2.0)/RAND_MAX)/256.0);
  output_wav = (int)(128.5+(dithered_wav*quant_step));
  output_wav -= 128;
  dequant_wav = (output_wav<<quant_step_int);
  if(dequant_wav>126)dequant_wav = 126;
  if(dequant_wav<-126)dequant_wav = -126;

  error_wav = biased_wav-(dequant_wav/256.0);
  if(error_wav<-0.05)error_wav = -0.05;
  if(error_wav>0.05)error_wav = 0.05;
  for(j=1;j<fb_max;j++){
   adpc->errors_bf[j] = adpc->errors_bf[j+1];
   adpc->errors_bf[j] += error_wav*adpc->feedbacks[j];
  }
  dequant_wav += 128;
  adpc->wav_comp[i] = (char)dequant_wav;
 }

 for(i=0;i<(BUF_SIZE-ADPCM_UNIT);i++){
  adpc->wav_buf[i] = adpc->wav_buf[i+ADPCM_UNIT];
 }
 return 0;
}


main(int argc, char **argv){
 char input_wav_path[4096] = "";
 char output_wav_path[4096] = "";
 int i,j,k;
 int input_sampling_rate;
 int input_wav_length;
 struct adpcm_common ADPC;
 struct adpcm_common *adpc;
 adpc = &ADPC;
 init_adpcm_common(adpc);
 short sbuf;
 FILE INPUT_WAV;
 FILE *input_wav;
 if(argc==1){
  printf("wav8bit.exe version 1.0.3 (http://d.hatena.ne.jp/kamedo2/)\r\n");
  printf("Monaural 16bit wav file to Monaural 8bit wav file. Very slow, high quality.\r\n\r\n");
  printf("  usage:  wav8bit input.wav [output.wav]\r\n");
  return 0;
 }
 if(1<argc){
  strcpy(input_wav_path,argv[1]);
  strcpy(output_wav_path,input_wav_path);
  int path_len = strlen(output_wav_path)-4;
  if(output_wav_path[path_len]=='.'){
   output_wav_path[path_len] = 0;
   strcat(output_wav_path,".8b.wav");
  }
 }
 if(2<argc){
  strcpy(output_wav_path,argv[2]);
 }

 printf("%s\r\n",input_wav_path);
 printf("%s\r\n",output_wav_path);


 char chunkstr[8] = {0};
 int chunk_length;
 int chunk_max = 10;
 if((input_wav = fopen(input_wav_path,"rb")) == NULL)return 1;
 fread(chunkstr,1,4,input_wav);
 if(strcmp(chunkstr,"RIFF")!=0)printf("RIFF != %s\r\n",chunkstr);
 fread(chunkstr,1,4,input_wav);
 fread(chunkstr,1,4,input_wav);
 if(strcmp(chunkstr,"WAVE")!=0)printf("WAVE != %s\r\n",chunkstr);
 fread(chunkstr,1,4,input_wav);
 while(strcmp(chunkstr,"fmt ")!=0 && (chunk_max>0)){
  printf("fmt  != %s\r\n",chunkstr);
  fread(&chunk_length,4,1,input_wav);
  for(i=0;i<chunk_length;i++)fread(chunkstr,1,1,input_wav);
  fread(chunkstr,1,4,input_wav);
  chunk_max--;
 }

 if(chunk_max){
  fread(&chunk_length,4,1,input_wav);
  fread(chunkstr,1,4,input_wav);
  if(chunkstr[0]!=1 || chunkstr[1]!=0){
   printf("This is not a linear PCM.\r\n");
   return 2;//linear PCM
  }
  if(chunkstr[2]!=1 || chunkstr[3]!=0){
   printf("This is not a Monaural sound(Stereo, Surround, etc.).\r\n");
   return 3;//Mono
  }
  fread(&input_sampling_rate,1,4,input_wav);
  for(i=0;i<chunk_length-8;i++)fread(chunkstr,1,1,input_wav);
 }

 fread(chunkstr,1,4,input_wav);
 while(strcmp(chunkstr,"data")!=0 && (chunk_max>0)){
  printf("data!=%s\r\n",chunkstr);
  fread(&chunk_length,4,1,input_wav);
  for(i=0;i<chunk_length;i++)fread(chunkstr,1,1,input_wav);
  fread(chunkstr,1,4,input_wav);
  chunk_max--;
 }
 if(chunk_max){
  fread(&input_wav_length,4,1,input_wav);
 }

 input_wav_length >>= 6;// 32 Blocks
 printf("SAMPLE RATE: %d\r\n",input_sampling_rate);
 printf(" FRAMES NUM: %d\r\n",input_wav_length);

 prepare_psycho_param(adpc,(double)input_sampling_rate);
 /*
 printf(" Hz:");
 for(i=0;i<BUF_HALF;i++){
  printf("%4.1f ",input_sampling_rate*(i+0.5)/BUF_SIZE);
 }
 printf("\r\nATH:");
 for(i=0;i<BUF_HALF;i++){
  printf("%4.1f ",adpc->ath_curve[i]);
 }
 printf("\r\nMSP:");
 for(i=0;i<BUF_HALF;i++){
  printf("%4.3f ",adpc->mask_spread[i]);
 }
 printf("\r\n");
 */

 FILE *output_wav;
 int intbuf;
 output_wav = fopen(output_wav_path,"wb");
 if(output_wav==NULL)return 4;
 fputs("RIFF",output_wav);
 intbuf = 44-8+(input_wav_length<<5);
 fwrite(&intbuf,4,1,output_wav);
 fputs("WAVE",output_wav);
 fputs("fmt ",output_wav);
 intbuf = 16;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = 65536+1;
 fwrite(&intbuf,4,1,output_wav);
 fwrite(&input_sampling_rate,4,1,output_wav);
 fwrite(&input_sampling_rate,4,1,output_wav);
 intbuf = 65536*8+1;
 fwrite(&intbuf,4,1,output_wav);
 fputs("data",output_wav);
 intbuf = (input_wav_length<<5);
 fwrite(&intbuf,4,1,output_wav);

 for(j=0;j<input_wav_length;j++){
  for(k=0;k<ADPCM_UNIT;k++){

   fread(&sbuf,2,1,input_wav);
   adpc->wav_buf[k+BUF_SIZE-ADPCM_UNIT] = ((double)sbuf)/65536.0;
  }
  adpc->sign_hist[0] = 0;
  adpc->sign_hist[0] = j&0x1FFF;
  adpcm(adpc);
  fwrite(adpc->wav_comp,1,ADPCM_UNIT,output_wav);
 }
 fclose(input_wav);
 fclose(output_wav);
 return 0;
}

